from corpy.udpipe import Model
from keybert import KeyBERT

"""
get keywords using KeyBert

Arguments:
    array_text: list of articles
    lan: datasets language
    n_gram: n gram range
    kw_count: list of keywords count of each article

Returns:
    kw: list of keywords
"""
def get_keywords(array_text, lan, n_gram, kw_count):
    if(lan == "cz"):
        bert_model = 'UWB-AIR/Czert-B-base-cased'
    else:
        bert_model = 'all-MiniLM-L12-v2'
    keywords = []
    kw = []
    kw_extractor = KeyBERT(model=bert_model)
    for j in range(len(array_text)):
        keywords = (kw_extractor.extract_keywords(array_text[j], top_n=len(kw_count[j]), keyphrase_ngram_range=(1,n_gram)))
        a, b = zip(*keywords)
        kw.append(a)
        #print(j)

    return kw