import csv
from itertools import count
import os
import spacy_udpipe
import nltk
import sys



article = 1
spacy_udpipe.download("cs")
nlp = spacy_udpipe.load("cs")


"""
Function to create all datasets by type of preprocessing (CTK-raw, CTK-raw filtrovane, CTK-lemma, CTK-lemma filtrovane)

Arguments: 
    datasets_to_create: which datasets are not created yet and need to be created
"""
def create_all_datasets(arts, kws, datasets_to_create):
    if not os.path.exists(kws):
        print("Cannot find file \"queries.csv\"")
        exit()

    if not os.path.exists(arts):
        print("Cannot find file \"summaries.csv\"")
        exit()
        
    f = open("Stopwords/stop_words_czech.txt", "r", encoding="UTF-8")
    cz_stopwords = f.read().splitlines()
    for dat in range(0, len(datasets_to_create)):
        article = 1
        if "filtered" in datasets_to_create[dat]:
            filtered = 1
        else:
            filtered = 0

        if "Lemma" in datasets_to_create[dat]:
            lemma = 1
        else:
            lemma = 0
        print(f"Creating dataset {datasets_to_create[dat]} in progress!")
        with open(kws, 'r', encoding="UTF-8") as file:
            bad_docs = []
            counter = 0
            reader = csv.reader(file)
            if not os.path.isdir(datasets_to_create[dat] + "keys"):
                os.makedirs(datasets_to_create[dat] + "keys")

            for row in reader:
                sw_in_doc = 0
                
                string = str(row)
                stripped_string = string.replace('"', "").replace('[', "").replace("'", "").replace(']', "").replace('.,', ' .')
                separate_string = stripped_string.split(',')

                sentence = []
                doc = nlp(stripped_string)

                for token in doc:
                    sentence.append(token.lemma_)

                res = ' '.join(word for word in sentence)
                

                if filtered == 1:
                    splitted = res.split(',')
                    one_occur = []
                    for k in range(0, len(splitted)):
                        if not splitted[k] in one_occur:
                            one_occur.append(splitted[k])
                    for word in one_occur:
                        clean_word = word.replace(" ", "")
                        if clean_word in cz_stopwords:
                            sw_in_doc += 1

                    if(len(one_occur) > 50 or (sw_in_doc >= (len(one_occur)/3))):
                        bad_docs.append(counter)
                        counter += 1
                        continue

                if lemma == 1:
                    separate_string = res.split(',')
                else:
                    separate_string = str(doc)
                    separate_string = separate_string.split(',')

                f = open(datasets_to_create[dat] + "keys/" + str(article) + ".txt", "w", encoding="UTF-8")
                for i in range(0, len(separate_string)):
                    final_str = separate_string[i].replace(" ", "")
                    f.write(final_str.lower()+"\n")
                f.close
                article += 1
                counter += 1
            article = 1

        
        with open(arts, 'r', encoding="UTF-8") as file:
            reader = csv.reader(file)
            counter_docs = 0
            if not os.path.isdir(datasets_to_create[dat] + "docs"):
                os.makedirs(datasets_to_create[dat] + "docs")
            for row in reader:
                string = str(row)
                stripped_string = string.replace('"', "").replace('[', "").replace("'", "").replace(']', "").replace('.,', ' .')
                sentence = []
                doc = nlp(stripped_string)
                token = 0

                if lemma == 1:
                    while token < len(doc):
                        abb_counter = token
                        abbrev = []
                        abbrev.append(doc[abb_counter].norm_)
                        
                        if (token + 1) < len(doc) and len(doc[token]) == 1 and doc[token].pos_ != "ADP":
                            while ((doc[abb_counter].text).isupper() or (doc[abb_counter].text).isdigit()) and ((doc[abb_counter+1].text).isupper() or (doc[abb_counter+1].text).isdigit()):
                                abbrev.append(doc[abb_counter+1].norm_)
                                abb_counter+=1
                                token = token + 1
                        
                        if(doc[token].lemma_ == "sv.Jilj"):
                            word = doc[token].lemma_ + doc[token + 1].lemma_
                            sentence.append(word)
                            token += 2
                            continue
                        if len(abbrev) > 1:
                            word = ''.join(abb for abb in abbrev)
                            sentence.append(word)
                            token += 1
                            continue
                        if("`" in doc[token].lemma_):
                            tok = doc[token].lemma_.split("`")
                            sentence.append(tok[0])
                            token += 1
                            continue
                        if("_" in doc[token].lemma_):
                            tok = doc[token].lemma_.split("_")
                            sentence.append(tok[0])
                            token += 1
                            continue

                        sentence.append(doc[token].lemma_)
                        token += 1

                    res = ' '.join(word for word in sentence)

                else:
                    while token < len(doc):
                        abb_counter = token
                        abbrev = []
                        abbrev.append(doc[abb_counter].norm_)
                        
                        if (token + 1) < len(doc) and len(doc[token]) == 1 and doc[token].pos_ != "ADP":
                            while ((doc[abb_counter].text).isupper() or (doc[abb_counter].text).isdigit()) and ((doc[abb_counter+1].text).isupper() or (doc[abb_counter+1].text).isdigit()):
                                abbrev.append(doc[abb_counter+1].norm_)
                                abb_counter+=1
                                token = token + 1

                        if len(abbrev) > 1:
                            word = ''.join(abb for abb in abbrev)
                            sentence.append(word)
                            token += 1
                            continue
                        if(doc[token].lemma_ == "sv.Jilj"):
                            word = doc[token].lemma_ + doc[token + 1].lemma_
                            sentence.append(word)
                            token += 2
                            continue
                        if("_" in doc[token].lemma_):
                            tok = doc[token].lemma_.split("_")
                            sentence.append(tok[0])
                            token += 1
                            continue
                        sentence.append(doc[token].text)
                        token += 1

                    res = ' '.join(word for word in sentence)
                if(counter_docs in bad_docs):
                    counter_docs += 1
                    continue
                else:
                    f = open(datasets_to_create[dat] + "docs/" + str(article) + ".txt", "w", encoding="UTF-8")
                    f.write(res)
                    f.close
                    article += 1
                    counter_docs += 1
                
            article = 1
        print(f"Dataset {datasets_to_create[dat]} created!")
    print("All datasets created!")



if len(sys.argv) != 3:
    print("Invalid count of arguments!\nPlease specify:\narg1: A csv file with articles\narg2: A csv file with keywords")
    exit()

articles = sys.argv[1]
kws = sys.argv[2]

datasets_to_create = []

if not os.path.isdir("CZ_dataset/Raw/docs") or not os.path.isdir("CZ_dataset/Raw/keys"):
    datasets_to_create.append("CZ_dataset/Raw/")
if not os.path.isdir("CZ_dataset/Lemma/docs") or not os.path.isdir("CZ_dataset/Lemma/keys"):
    datasets_to_create.append("CZ_dataset/Lemma/")
if not os.path.isdir("CZ_dataset/Lemma_filtered/keys") or not os.path.isdir("CZ_dataset/Lemma_filtered/docs"):
    datasets_to_create.append("CZ_dataset/Lemma_filtered/")
if not os.path.isdir("CZ_dataset/Raw_filtered/keys") or not os.path.isdir("CZ_dataset/Raw_filtered/docs"):
    datasets_to_create.append("CZ_dataset/Raw_filtered/")

create_all_datasets(articles, kws, datasets_to_create)