from summa import keywords
from nltk.stem import WordNetLemmatizer
  
wnl = WordNetLemmatizer()


"""
get keywords using TextRank

Arguments:
    array_text: list of articles
    lan: datasets language
    n_gram: n gram range
    kw_count: list of keywords count of each article

Returns:
    kw: list of keywords
"""
def get_keywords(array_text, lan, n_gram, kw_count):
    kw_array = []
    for j in range(len(array_text)):
        kw = (keywords.keywords(array_text[j], words=len(kw_count[j]), split=True))
        lemma = []
        for phrase in kw:
            if(" " in phrase):
                splitted_phrase = phrase.split(" ")
                lemmatized_output = ' '.join([wnl.lemmatize(w) for w in splitted_phrase])
                lemma.append(lemmatized_output)
            else:
                lemmatized_output = wnl.lemmatize(phrase)
                lemma.append(lemmatized_output)
        kw_array.append(lemma)

    return kw_array